--- Kleiner

local function SonicModelExists()
    if SonicSD and file.Exists("models/weapons/c_sonicsd.mdl", "GAME") then
        return true
    end
    return false
end

local T = {}

T.Versions = {
    randomize = false,
    allow_custom = true,
    randomize_custom = false,

    main = {
        id = "kleiner",
    },
    other = {
		{
			name = "Large Entrance",
			id = "kleinercl",
		},
	}
}

T.EnableClassicDoors = false

T.Base = "base"
T.Name = "Kleiner's Lab"
T.ID = "kleiner"
T.Interior = {
    Model = "models/FuzzyLeo/Kleiner/labbase.mdl",
    IdleSound = {
        {
            path = "ambient/machines/lab_loop1.wav",
            volume = 0.5
        },
    },
    Light = {
        color = Color(238, 225, 200),
        warncolor = Color(255, 60, 60),
        pos = Vector(102, 51, 169),
        brightness = 2,
    },
    Lights = {
        {
            color = Color(255, 249, 204),
            warncolor = Color(255, 60, 60),
            pos = Vector(-385, 100, 115),
            brightness = 2,
            nopower = false
        },
        {
            color = Color(255, 249, 204),
            warncolor = Color(255, 60, 60),
            pos = Vector(-13, -70, 100),
            brightness = 1,
            nopower = false
        },
    },
    Lamps = {
        sun = false,
        sun2 = false,
        lamp1 = {
            color = Color(184, 196, 207),
            texture = "effects/flashlight/soft",
            fov = 93.462585449219,
            distance = 130,
            brightness = 0.5,
            pos = Vector(431.1142578125, 107.15625, 131.052734375),
            ang = Angle(52.88208770752, 61.15894317627, -95.808807373047),
            shadows = false,
            warn = {
                -- same list of options available
                sprite_brightness = 0.5,
                color = Color(255, 60, 60),
            },
        },
        lamp2 = {
            color = Color(244, 243, 232),
            texture = "effects/flashlight/soft",
            fov = 73.075912475586,
            distance = 64,
            brightness = 0.3,
            pos = Vector(314, 258.55, 91.5),
            ang = Angle(-12, 90, -90),
            warn = {
                -- same list of options available
                sprite_brightness = 0.5,
                color = Color(255, 60, 60),
            },
        },
        lamp3 = {
            color = Color(255, 227, 116),
            texture = "effects/flashlight/soft",
            fov = 83.935813903809,
            distance = 300,
            brightness = 1.5,
            pos = Vector(267.56527709961, -229.22705078125, 246.5029296875),
            ang = Angle(76.787445068359, 19.771589279175, 0),
            shadows = false,
            sprite = true,
            warn = {
                -- same list of options available
                sprite_brightness = 0.5,
                color = Color(255, 60, 60),
            },
        },
    },
    Portal = {
        -- Generated by portals debug tool
        pos = Vector(314.9375, 351, 47.0634765625),
        ang = Angle(-0, -90, 0),
        width = 181,
        height = 300,
        thickness = 45,
        exit_point_offset = {
            pos = Vector(0,0,0.1),
            ang = Angle(0, 0, 0),
        },
        inverted = true,
    },
    Fallback = {
        pos = Vector(315, 332, 3.043),
        ang = Angle(0, 230, 0)
    },
    Screens = {
        {
            pos = Vector(154, 212, 49.8),
            ang = Angle(0, -53, 82.5),
            width = 245,
            height = 205.5,
            gui_rows = 2,
            power_off_black = true
        }
    },
    Scanners = {
        {
            mat = "models/fuzzyleo/tardisscanner",
            width = 1024,
            height = 1024,
            ang = Angle(0,0,0),
            fov = 90,
        }
    },
    ExitDistance = 1000,
    Sounds = {
        Teleport = { },
        Cloister = "ambient/alarms/combine_bank_alarm_loop4.wav",
    },
    Sequences = "kleiner_sequence",
    Parts = {
        door = {
            Model="models/tardis/props/vendingmachinedoor.mdl",
            posoffset=Vector(16.07, 0, -49.08),
        },
        kleiner_base2            =   {pos = Vector(0, 0, 0),                     ang = Angle(-0, 0, 0),               },
        kleiner_base3            =   {pos = Vector(0, 0, 0),                     ang = Angle(-0, 0, 0),               },
        kleiner_teleportroom            =   {pos = Vector(0, 0, 0),                     ang = Angle(-0, 0, 0),               },
        kleiner_teleportroom2            =   {pos = Vector(0, 0, 0),                     ang = Angle(-0, 0, 0),               },
        kleiner_console1            =   {pos = Vector(164, 187, 0),                     ang = Angle(0, 270, 0),               },
        kleiner_computerbank            =   {pos = Vector(91, 237, 0),                     ang = Angle(0, 275, 0),               },
        kleiner_computerbank2            =   {pos = Vector(91, 237, 0),                     ang = Angle(0, 275, 0),               },
        kleiner_tank            =   {pos = Vector(-82, 261, 0),                     ang = Angle(0, 270, 0),               },
        kleiner_tankconsole            =   {pos = Vector(8, 158, 0),                     ang = Angle(0, 270, 0),               },
        kleiner_consolekeyboard            =   {pos = Vector(148, 167, 30),                     ang = Angle(0, 191.5, 0),               },
        kleiner_tankconsolekeyboard            =   {pos = Vector(29, 156, 30),                     ang = Angle(0, 337, 0),               },
        kleiner_printer            =   {pos = Vector(170, 121, 0),                     ang = Angle(0, 180, 0),               },
        kleiner_tankglass1            =   {pos = Vector(-50, 185, 9),                     ang = Angle(0, 0, 0),               },
        kleiner_tankglass2            =   {pos = Vector(-93, 146, 9),                     ang = Angle(0, 0, 0),               },
        kleiner_locker            =   {pos = Vector(192, -121, 0),                     ang = Angle(0, 90, 0),               },
        kleiner_lockerdoora            =   {pos = Vector(207, -111, 38),                     ang = Angle(0, 90, 0),               },
        kleiner_lockerdoorb            =   {pos = Vector(192, -111, 38),                     ang = Angle(0, 90, 0),               },
        kleiner_lockerdoorc            =   {pos = Vector(176, -111, 38),                     ang = Angle(0, 90, 0),               },
        kleiner_book1            =   {pos = Vector(181, -126, 71.4),                     ang = Angle(0, 60, -90),               },
        kleiner_kennel            =   {pos = Vector(62, -123, 1),                     ang = Angle(0, 96, 0),               },
        kleiner_monitor            =   {pos = Vector(128, -246, 37),                     ang = Angle(0, 115, 0),               },
        kleiner_book2            =   {pos = Vector(168, -248, 37),                     ang = Angle(-1.79406, 97.7975, 12.8777),               },
        kleiner_book3            =   {pos = Vector(161, -247, 53),                     ang = Angle(0, 90, 90),               },
        kleiner_hose            =   {pos = Vector(-20, -21, 0),                     ang = Angle(0, 270, 0),               },
        kleiner_consolebox            =   {pos = Vector(55, -224, 37),                     ang = Angle(0, 90, 0),               },
        kleiner_cardboardbox1            =   {pos = Vector(50, -246, 65),                     ang = Angle(0, 268, 0),               },
        kleiner_cardboardbox2            =   {pos = Vector(-45, -242, 14),                     ang = Angle(0, 274, 0),               },
        kleiner_security            =   {pos = Vector(435, -20, 0),                     ang = Angle(0, 180, 0),               },
        kleiner_filecabinet            =   {pos = Vector(423, 241, 15),                     ang = Angle(0, 180, 0),               },
        kleiner_miniteleport            =   {pos = Vector(427, 210, 36),                     ang = Angle(0, 180, 0),               },
        kleiner_cardboardbox3            =   {pos = Vector(424, 129, 13),                     ang = Angle(0, 274, 0),               },
        kleiner_hula            =   {pos = Vector(409, 7, 34),                     ang = Angle(0, 195, 0),               },
        kleiner_radio            =   {pos = Vector(425, 49, 52),                     ang = Angle(0, 180, 0),               },
        kleiner_can            =   {pos = Vector(28, 184, 44),                     ang = Angle(0, 337, 0),               },
        kleiner_fence1            =   {pos = Vector(-31, -156, 50),                     ang = Angle(0, 270, 0),               },
        kleiner_cardboardbox4            =   {pos = Vector(-86, -242, 23),                     ang = Angle(-3, 271.037, 40),               },
        kleiner_ladder            =   {pos = Vector(-136, -154, 0),                     ang = Angle(0, 90, 0),               },
        kleiner_laddertop            =   {pos = Vector(-136, -154, 112),                     ang = Angle(0, 90, 0),               },
        kleiner_fence2            =   {pos = Vector(-39, -200, 166),                     ang = Angle(0, 0, 0),               },
        kleiner_fence3            =   {pos = Vector(2, -163, 166),                     ang = Angle(0, 270, 0),               },
        kleiner_server            =   {pos = Vector(372, 86, 16),                     ang = Angle(0, 90, 0),               },
        kleiner_crate1            =   {pos = Vector(372, 93, 40),                     ang = Angle(0, 268.5, 0),               },
        kleiner_server2            =   {pos = Vector(393, 92, 52),                     ang = Angle(0, 105, 0),               },
        kleiner_server3            =   {pos = Vector(413, 124, 36),                     ang = Angle(0, 163, 0),               },
        kleiner_book4            =   {pos = Vector(425, 146, 38),                     ang = Angle(0, 75, -90),               },
        kleiner_book5            =   {pos = Vector(437, 140, 58),                     ang = Angle(0, 180, 48.5),               },
        kleiner_book6            =   {pos = Vector(436, 148, 58),                     ang = Angle(0, 180, 30),               },
        kleiner_server4            =   {pos = Vector(435, 119, 76),                     ang = Angle(0, 150, 0),               },
        kleiner_suitcharger            =   {pos = Vector(-256, -178, 48),                     ang = Angle(0, 0, 0),               },
        kleiner_server5            =   {pos = Vector(140, -179, 113),                     ang = Angle(0, 90, 0),               },
        kleiner_bucket            =   {pos = Vector(152, -184, 130),                     ang = Angle(0, 56, 0),               },
        kleiner_canister            =   {pos = Vector(99, -185, 142),                     ang = Angle(0, 225, 0),               },
        kleiner_jar1            =   {pos = Vector(116, -200, 152),                     ang = Angle(0, 296, 0),               },
        kleiner_jar2            =   {pos = Vector(100, -204, 152),                     ang = Angle(0, 146, 0),               },
        kleiner_monitor2            =   {pos = Vector(98, -244, 176),                     ang = Angle(0, 41, 0),               },
        kleiner_crate2            =   {pos = Vector(0, -240, 132),                     ang = Angle(0, 90, -180),               },
        kleiner_crate3            =   {pos = Vector(-64, -237, 146),                     ang = Angle(0, 90, 90),               },
        kleiner_crate4            =   {pos = Vector(-178, -242, 132),                     ang = Angle(0, 90, 180),               },
        kleiner_crate5            =   {pos = Vector(-234, -242, 146),                     ang = Angle(0, 90, 90),               },
        kleiner_light1            =   {pos = Vector(229, -8, 247),                     ang = Angle(0, 270, 0),               },
        kleiner_light2            =   {pos = Vector(1, -8, 247),                     ang = Angle(0, 270, 0),               },
        kleiner_light3            =   {pos = Vector(-152, -8, 247),                     ang = Angle(0, 270, 0),               },
        kleiner_light4            =   {pos = Vector(229, 118, 247),                     ang = Angle(0, 270, 0),               },
        kleiner_light5            =   {pos = Vector(1, 118, 247),                     ang = Angle(0, 270, 0),               },
        kleiner_keypad            =   {pos = Vector(254, -136, 53),                     ang = Angle(0, 90, 0),               },
        kleiner_hevmachine            =   {pos = Vector(274, -216, -1),                     ang = Angle(0, 270, 0),               },
        kleiner_hevcase            =   {pos = Vector(316, -225, -1),                     ang = Angle(0, 90, 0),               },
        kleiner_windowvent            =   {pos = Vector(-416, -140, 136),                     ang = Angle(0, 270, 0),               },
        kleiner_consoleteleport            =   {pos = Vector(-448, -120, 104),                     ang = Angle(0, 270, 0),               },
        kleiner_recievercart1            =   {pos = Vector(-450, -102, 40),                     ang = Angle(0, 75, 0),               },
        kleiner_recievercart2            =   {pos = Vector(-396, -108, 40),                     ang = Angle(0, 90, 0),               },
        kleiner_computerbank3            =   {pos = Vector(-499, -28, 0),                     ang = Angle(0, 0, 0),               },
        kleiner_teleportbulk            =   {pos = Vector(-376, 73, 128),                     ang = Angle(0, 270, 0),               },
        kleiner_teleporter            =   {pos = Vector(-387, 257, -2),                     ang = Angle(0, 270, 0),               },
        kleiner_powerbox1            =   {pos = Vector(-499, 160, 25),                     ang = Angle(0, 0, 0),               },
        kleiner_powerbox2            =   {pos = Vector(-499, 196, 25),                     ang = Angle(0, 0, 0),               },
        kleiner_powerbox3            =   {pos = Vector(-499, 232, 25),                     ang = Angle(0, 0, 0),               },
        kleiner_light6            =   {pos = Vector(-464, 171, 199),                     ang = Angle(0, 0, 0),               },
        kleiner_light7            =   {pos = Vector(-295, 171, 199),                     ang = Angle(0, 0, 0),               },
        kleiner_tpswitch            =   {pos = Vector(-277, 127, 44),                     ang = Angle(0, 180, 0),               },
        kleiner_plugs            =   {pos = Vector(-272, 165, 44),                     ang = Angle(0, 180, 0),               },
        kleiner_pipe1            =   {pos = Vector(-273, 124, 83),                     ang = Angle(0, 180, 0),               },
        kleiner_pipe2            =   {pos = Vector(-273, 128, 78),                     ang = Angle(0, 180, 0),               },
        kleiner_pipe3            =   {pos = Vector(-273, 133, 77),                     ang = Angle(0, 180, 180),               },
        kleiner_pipe4            =   {pos = Vector(-273, 133, 114),                     ang = Angle(0, 180, 180),               },
        kleiner_pipebox            =   {pos = Vector(-277, 126, 116),                     ang = Angle(0, 180, 0),               },
        kleiner_teleportgrate1            =   {pos = Vector(-386, 172, 27),                     ang = Angle(0, 270, 0),               },
        kleiner_teleportgrate2            =   {pos = Vector(-386, 172, 47),                     ang = Angle(0, 270, 0),               },
        kleiner_teleportgrate3            =   {pos = Vector(-386, 172, 67),                     ang = Angle(0, 270, 0),               },
        kleiner_teleportplatform            =   {pos = Vector(-387, 227, 6),                     ang = Angle(0, 270, 0),               },
        kleiner_teleportring1            =   {pos = Vector(-387, 223, 12),                     ang = Angle(0, 90, 0),               },
        kleiner_teleportring2            =   {pos = Vector(-387, 223, 24),                     ang = Angle(0, 90, 0),               },
        kleiner_teleportring3            =   {pos = Vector(-387, 223, 35),                     ang = Angle(0, 90, 0),               },
        kleiner_teleportring4            =   {pos = Vector(-387, 223, 47),                     ang = Angle(0, 90, 0),               },
        kleiner_plug            =   {pos = Vector(-277, 152, 54),                     ang = Angle(0, 180, 0),               },
        kleiner_doorframe            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        kleiner_doorvoid            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        kleiner_magnify            =   {pos = Vector(164, 146, 30),                     ang = Angle(0, 330, 0),               },
        kleiner_lamp1            =   {pos = Vector(314, 296, 104),                     ang = Angle(0, 270, 0),               },
        kleiner_lamp2            =   {pos = Vector(-256, 335, 111),                     ang = Angle(0, 0, 0),               },
        kleiner_lamp3            =   {pos = Vector(67, 376, 63),                     ang = Angle(0, 270, 0),               },
        kleiner_lamp4            =   {pos = Vector(-80, -188, 108),                     ang = Angle(0, 90, 0),               },
        kleiner_lampsmalltp            =   {pos = Vector(432, 109, 128),                     ang = Angle(58.0892, 60.6835, 64.5135),               },
        kleiner_lampsmalltpbase            =   {pos = Vector(440, 112, 131),                     ang = Angle(75, 0, 0),               },
        kleiner_boxlamp1            =   {pos = Vector(441, -200, 115),                     ang = Angle(45, 180, 0),               },
        kleiner_boxlamp2            =   {pos = Vector(268, -229, 247),                     ang = Angle(90, 180, 0),               },
        kleiner_crate6            =   {pos = Vector(433, -198, 9),                     ang = Angle(0, 80, 0),               },
        kleiner_crate7            =   {pos = Vector(433, -167, 9),                     ang = Angle(0, 5, 0),               },
        kleiner_cardboardbox5            =   {pos = Vector(414, -238, 14),                     ang = Angle(0, 4, 0),               },
        kleiner_boxkeypostwhatever            =   {pos = Vector(441, -165, 48),                     ang = Angle(0, 180, -180),               },
        kleiner_demathitbox            =   {pos = Vector(146, 175, 31),                     ang = Angle(0, 0, 0),               },
        kleiner_coordshitbox            =   {pos = Vector(146, 160, 31),                     ang = Angle(0, 0, 0),               },
        kleiner_manualflighthitbox            =   {pos = Vector(161, 174, 46),                     ang = Angle(0, 0, 0),               },
        kleiner_securityhitbox            =   {pos = Vector(408, -30, 36),                     ang = Angle(0, 0, 0),               },
        kleiner_flighthitbox            =   {pos = Vector(97, 224, 73),                     ang = Angle(0, 0, 0),               },
        kleiner_screenstogglehitbox            =   {pos = Vector(154, 224.5, 40),                     ang = Angle(0, 0, 0),               },
        kleiner_doorlockhitbox            =   {pos = Vector(153, 221, 58),                     ang = Angle(0, 0, 0),               },
        kleiner_enginereleasehitbox            =   {pos = Vector(147.5, 171.6, 10),                     ang = Angle(0, 0, 0),               },
        kleiner_doortogglehitbox            =   {pos = Vector(156.5, 196, 58),                     ang = Angle(0, 0, 0),               },
        kleiner_powerhitbox            =   {pos = Vector(15.4, 167.4, 48),                     ang = Angle(0, 0, 0),               },
        kleiner_manualcoords            =   {pos = Vector(159, 230.5, 66.3),                     ang = Angle(0, 0, 0),               },
        kleiner_hadshitbox            =   {pos = Vector(32.4, 162.4, 31.5),                     ang = Angle(0, 0, 0),               },
        kleiner_repair            =   {pos = Vector(16.5, 148, 43),                     ang = Angle(0, 0, 0),               },
        kleiner_redecorate            =   {pos = Vector(77, 225.5, 54),                     ang = Angle(0, 0, 0),               },
        kleiner_handbrake            =   {pos = Vector(26, 146.5, 30),                     ang = Angle(0, 0, 0),               },
        kleiner_fastreturn            =   {pos = Vector(155, 210.5, 57),                     ang = Angle(0, 0, 0),               },
        kleiner_physlock            =   {pos = Vector(77, 225.5, 61),                     ang = Angle(0, 0, 0),               },
        kleiner_isomorphic            =   {pos = Vector(24, 164, 41),                     ang = Angle(0, 0, 0),               },
        kleiner_float            =   {pos = Vector(109, 225.5, 65),                     ang = Angle(0, 0, 0),               },
        kleiner_cloak            =   {pos = Vector(77, 225.5, 44.6),                     ang = Angle(0, 0, 0),               },
        kleiner_longflighttoggle            =   {pos = Vector(54.7, 223.5, 13.3),                     ang = Angle(0, 0, 0),               },
        kleiner_sonicdispense            =   {pos = Vector(407.185, 240.996, 21.524),                     ang = Angle(0, 0, 0),               },
        kleiner_lampdoor            =   {pos = Vector(-247, -72, 126),                     ang = Angle(90, 0, 0),               },
        kleiner_slidingdoor            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        kleiner_hevdoor            =   {pos = Vector(0, 0, 0),                     ang = Angle(0, 0, 0),               },
        kleiner_picture            =   {pos = Vector(-255, -91, 60),                     ang = Angle(0, 0, 9),               },
        kleiner_eyescanner            =   {pos = Vector(-230, -120, 42),                     ang = Angle(20, 90, 0),               },
        kleiner_minitppart            =   {pos = Vector(424, 242, 26),                     ang = Angle(0, 180, 0),               },
        kleiner_minitppart2            =   {pos = Vector(424, 177, 32),                     ang = Angle(0, 180, 0),               },
    },
    Controls = {
        kleiner_demathitbox            = "teleport_double",
        kleiner_flighthitbox         = "flight",
        default_screen              = nil,
        kleiner_screenstogglehitbox        = "toggle_screens",
        kleiner_securityhitbox       = "toggle_scanners",
        kleiner_doorlockhitbox         = "doorlock",
        kleiner_enginereleasehitbox       = "engine_release",
        kleiner_doortogglehitbox          = "door",
        kleiner_powerhitbox          = "power",
        kleiner_manualcoords            = "destination",
        kleiner_hadshitbox                = "hads",
        kleiner_coordshitbox          = "coordinates",
        kleiner_repair         = "repair",
        kleiner_redecorate    = "redecorate",
        kleiner_handbrake           = "handbrake",
        kleiner_radio          = "music",
        kleiner_fastreturn            = "fastreturn",
        kleiner_physlock            = "physlock",
        kleiner_isomorphic          = "isomorphic",
        kleiner_float               = "float",
        kleiner_cloak         = "cloak",
        kleiner_longflighttoggle    = "vortex_flight",
        default_dematcircuit        = nil,
        kleiner_sonicdispense      = "sonic_dispenser",
        default_sonic_inserted      = SonicModelExists() and "sonic_dispenser",
        kleiner_manualflighthitbox              = "thirdperson",
        default_atomaccel           = "spin_toggle",
        default_directionalpointer  = "spin_switch",



    },
    Tips = {},
    -- Interior.Tips are deprecated; should be deleted when the extensions update and
    -- replace with Interior.CustomTips, Interior.PartTips and Interior.TipSettings
    TipSettings = {
        view_range_min = 70,
        view_range_max = 90,
    },
    CustomTips = {
        --{ text = "Example", pos = Vector(0, 0, 0) },
    },
    PartTips = {

        kleiner_demathitbox            =   {pos = Vector(146, 175, 31), down = true},
        kleiner_coordshitbox            =   {pos = Vector(150, 160, 31), down = true},
        kleiner_manualflighthitbox            =   {pos = Vector(161, 174, 46), down = true},
        kleiner_securityhitbox            =   {pos = Vector(408, -30, 36), down = true},
        kleiner_flighthitbox            =   {pos = Vector(97, 224, 71.5), down = true},
        kleiner_screenstogglehitbox            =   {pos = Vector(154, 224.5, 40), down = true},
        kleiner_doorlockhitbox            =   {pos = Vector(152, 221, 56), down = true},
        kleiner_enginereleasehitbox            =   {pos = Vector(147.5, 171.6, 10), down = true},
        kleiner_doortogglehitbox            =   {pos = Vector(152.5, 196, 58), down = true},
        kleiner_powerhitbox            =   {pos = Vector(15.4, 167.4, 48), down = true},
        kleiner_manualcoords            =   {pos = Vector(159, 230.5, 66.3), down = true},
        kleiner_hadshitbox            =   {pos = Vector(32.4, 162.4, 31.5), down = true},
        kleiner_repair            =   {pos = Vector(16.5, 148, 43), down = true},
        kleiner_redecorate            =   {pos = Vector(77, 225.5, 54), down = true},
        kleiner_radio            =   {pos = Vector(416, 54, 62), down = true},
        kleiner_fastreturn            =   {pos = Vector(151, 210.5, 55), down = true},
        kleiner_handbrake            =   {pos = Vector(26, 146.5, 30), down = true},
        kleiner_physlock            =   {pos = Vector(77, 225.5, 61), down = true},
        kleiner_isomorphic            =   {pos = Vector(24, 164, 41), down = true},
        kleiner_float            =   {pos = Vector(109, 225.5, 65), down = true},
        kleiner_cloak            =   {pos = Vector(77, 225.5, 44.6), down = true},
        kleiner_longflighttoggle            =   {pos = Vector(54.7, 223.5, 13.3), down = true},
        kleiner_sonicdispense            =   {pos = Vector(407.185, 240.996, 21.524), down = true},
    },
    LightOverride = {
        basebrightness = 0.03 ,
        nopowerbrightness = 0.0025
    },
    Seats = {
        {
            pos = Vector(130, -96, -30),
            ang = Angle(0, 40, 0)
        },
        {
            pos = Vector(125, 55, -30),
            ang = Angle(0, 135, 0)
        }
    },
    BreakdownEffectPos = Vector(114, 215, 40),
}

T.Exterior = {
    Model="models/tardis/props/vendingmachine.mdl",
    DoorAnimationTime = 0.8,
    Parts = {
        door = {
            Model="models/tardis/props/vendingmachinedoor.mdl",
            posoffset=Vector(-16.07, 0, -49.08)
        },
        vortex = {
            model = "models/FuzzyLeo/Kleiner/vortex2.mdl",
            pos = Vector(0,0,50),
            ang = Angle(0,0,0),
            scale =10
        },
    },
    Sounds = {
        Teleport = {
            demat = "FuzzyLeo/kleinerdemat.wav",
            mat = "FuzzyLeo/kleinerremat.wav",
            mat_fast = "ambient/machines/teleport3.wav",
            mat_damaged_fast = "p00gie/tardis/mat_damaged_fast.wav",
            fullflight = "ambient/machines/teleport3.wav",
            interrupt = "drmatt/tardis/repairfinish.wav",
        },
        Spawn = "ambient/alarms/warningbell1.wav",
        RepairFinish = "drmatt/tardis/repairfinish.wav",
        Delete = "friends/friend_online.wav",
        Door={
			enabled=true,
			open="FuzzyLeo/vendingmove.wav",
			close="FuzzyLeo/vendingmove.wav",
            locked = "doors/door_locked2.wav"
		},
        FlightLoop = "ambient/levels/citadel/zapper_ambient_loop1.wav",
        FlightLoopDamaged = "drmatt/tardis/flight_loop_damaged.wav",
    },
    ProjectedLight = {
        --color = Color(r,g,b), --Base color. Will use main interior light if not set.
        --warncolor = Color(r,g,b), --Warning color. Will use main interior warn color if not set.
        brightness = 0.1, --Light's brightness
        vertfov = 80,
        horizfov = 50, --vertical and horizontal field of view of the light. Will default to portal height and width.
        farz = 750, --FarZ property of the light. Determines how far the light projects.]]
        offset = Vector(-16.5, 0, 40), --Offset from box origin
        texture = "effects/flashlight/square" --Texture the projected light will use. You can get these from the Lamp tool.
    },
    Light={
        enabled=false,
    },
    Portal = {
        -- Generated by portals debug tool
        pos = Vector(16.073944091797, 0.043543815612793, 49.0751953125),
        ang = Angle(-0, 6.8301892497402e-06, 0),
        width = 49,
        height = 91,
    },
    Teleport = {
        SequenceSpeed = 20,
        SequenceSpeedWarning = 1,
        SequenceSpeedFast = 20,
        SequenceSpeedWarnFast = 10,
        DematSequence = {
            200,
            100,
            150,
            0
        },
        DematSequenceDelays={
            [1] = 4.5
        },
        MatSequence = {
            50,
            100,
            50,
            255
        },
        MatSequenceDelays={
            [2] = 0
        },
    },
}

T.CustomSettings = {
    interior_sunlight = {
        text = "Sun Colour",
        value_type = "list",
        value = "defaultsun",
        options = {
            ["defaultsun"] = "Cold White (Default)",
            ["dusk"] = "Dusk/Dawn",
            ["night"] = "Night",
            ["noon"] = "Noon",
            ["cloudy"] = "Cloudy",
        }
    },
}

T.Templates = {

    kleiner_defualtsun = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_sunlight", ply)
            return (setting_val == "defaultsun")
        end,
	},

    kleiner_dusk = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_sunlight", ply)
            return (setting_val == "dusk")
        end,
	},

    kleiner_night = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_sunlight", ply)
            return (setting_val == "night")
        end,
	},

    kleiner_noon = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_sunlight", ply)
            return (setting_val == "noon")
        end,
	},

    kleiner_cloudy = {
		override = true,
        condition = function(id, ply, ent)
            local setting_val = TARDIS:GetCustomSetting(id, "interior_sunlight", ply)
            return (setting_val == "cloudy")
        end,
	},

}

local function playerlookingat(self,ply,vec,fov,width)
    local disp = vec - self:WorldToLocal(ply:GetPos()+Vector(0,0,64))
    local dist = disp:Length()

    local maxcos = math.abs( math.cos( math.acos( dist / math.sqrt( dist * dist + width * width ) ) + fov * ( math.pi / 180 ) ) )
    disp:Normalize()

    if disp:Dot( ply:EyeAngles():Forward() ) > maxcos then
        return true
    end

    return false
end

T.Interior.CustomHooks = {
    init_rotor = {
        "Initialize",
        function(self)
            self.timerotor={}
            self.timerotor.pos=0
            self.timerotor.mode=1
        end
    },
    think_rotor = {
        "Think",
        function(self)
            local moving = self.exterior:GetData("teleport",false)
            local flightmode = self.exterior:GetData("flight",false)
            local active = (moving or flightmode)
            if not CLIENT then return end
            if active or self.timerotor.pos > 0 then
                if self.timerotor.pos==1 then
                    self.timerotor.mode=0
                elseif active and self.timerotor.pos==0 then
                    self.timerotor.mode=1
                end
                self.timerotor.pos=math.Approach( self.timerotor.pos, self.timerotor.mode, FrameTime()*1.1 )
                self:SetPoseParameter( "glass", self.timerotor.pos )
            end
        end,
    },
    use_console = {
        "Use",
        function(self,a,c)
            if SERVER and a:IsPlayer() and (not a:GetTardisData("outside")) and CurTime() > a:GetTardisData("outsidecool",0) then
                local pos=Vector(0,0,0)
                local pos2=self:WorldToLocal(a:GetPos())
                local distance=pos:Distance(pos2)
                if distance < 110 and playerlookingat(self,a,pos,10,10) then
                    TARDIS:Control("thirdperson_careful", a)
                end
            end
        end,
    },
}

local function is_selected_exterior(id, ply, ent, this_setting)
	if TARDIS:GetInterior(id).EnableClassicDoors ~= true then
		return false
	end

	local setting = TARDIS:GetCustomSetting(id, "exterior", ply)

	if setting ~= "random" then
		return (setting == this_setting)
	end

	local data = ent:GetData("hellbent_selected_exterior")
	if data ~= nil then
		return (this_setting == data)
	end
end


TARDIS:AddInterior(T)
